(** Boolean implements the feature values. The Boolean module is of type {!Value.VALUE_TYPE}.

    author: Jeff Heinz

    last updated : October 1, 2006
*)

include X.X_TYPE
    (** The following list summarizes the function in [X.X_TYPE].
	- Type [t] is a boolean.
	- [name] is ["Bool"]. 
	- [compare] is the same as [Pervasives.compare]. 
	- [pair b1 b2] returns [b2].
	- [of_string] maps ["+"] to [true] and ["-"] to [false] and ["0"] raises [Failure("Unspecified")].
	- [to_string] maps [true] to ["+"] and [false] to ["-"].
	- [print] prints a boolean followed by an endline.
	- [print_] prints a boolean but no endline.

 *)

(** [max = true] *)
val max : t

(** [min = false] *)
val min : t

(** [op1 b = not b]. Thus the one place operation is negation. *)
val op1 : t -> t 
