(* Make sure the tools.cma is loaded *)

#load "feature.cma";;

(* Features are partial functions from elements to values *)

module Fmap = Xmap.Make(Phone)(Boolean)(Delim.Mp);;

Fmap.name;;

let high = Fmap.of_file "examples/high";;
Fmap.print high;;
let ha = Fmap.find (Phone.of_string "a") high;;
Boolean.print ha;;

let back = Fmap.of_file "examples/back";;
Fmap.print back;;
let ba = Fmap.find (Phone.of_string "a") back;;

let fb = Fmap.pair high back;;
Fmap.print fb;;

let smaller d1 d2 = 
  if Boolean.compare d1 d2 >= 0 
  then d2
  else d1;;

Boolean.print (smaller ba ha);;

(* Setting up a feature system *)

module PhoneSet = Xset.Make(Delim.Comma_no_bs)(Phone)
module Word = Xlist.Make(Delim.None)(Phone)
module WordSet = Xset.Make(Delim.Newline_no_bs)(Word)

module F = Feature.Make(Name)(Boolean)
module Fb = Bundle.Make(Delim.Bar_sqbs)(F)
module Fbword = Xlist.Make(Delim.None)(Fb)
module FbwordSet = Xset.Make(Delim.Newline_no_bs)(Fbword)

module Fsys = System.Make
  (Phone)(PhoneSet)(Word)(WordSet)(Name)(Boolean)(F)(Fb)(Fbword)(FbwordSet)

let t = Fsys.of_file "examples/vowels";;
Fsys.to_file t "examples/vowels_backup";;


(* I'll get to the rest of this soon. *)

(* Setting up the natural class module *)

(* Setting up the partition module *)


